<?php

defined('MOODLE_INTERNAL') || die();

require_once("$CFG->dirroot" . "/lib/navigationlib.php");

/* Export plugin hook to extend the main navigation, see also local/readme.txt */

function local_courses_extend_settings_navigation(settings_navigation $nav, context $context)
{
    global $COURSE;

    $coursenode = $nav->get('courseadmin');
    if ($coursenode == False)
        return;

    $coursecontext = get_context_instance(CONTEXT_COURSE, $COURSE->id);
    if (! has_capability('moodle/course:update', $coursecontext))
        return;

    $url = new moodle_url('/local/courses/index.php', array('id'=>$COURSE->id));
    $coursenode->add(get_string('courseattributessetting', 'local_courses'), $url);
}
