<?php

/**
 * Extensions of course management needed for integration with STAG systems.
 *
 * @package    localstagcourse
 */

$functions = array(
	'stag_create_course' => array(
		'classname'   => 'local_stag_course_external',
		'methodname'  => 'stag_create_course',
		'classpath'   => 'local/stag/externallib.php',
		'description' => 'Creates course with STAG attributes',
		'type'        => 'write',
	),

        'stag_get_courses'   => array(
                'classname'   => 'local_stag_course_external',
                'methodname'  => 'stag_get_courses',
                'classpath'   => 'local/stag/externallib.php',
                'description' => 'Returns information on course, including STAG attributes',
                'type'        => 'read',
        ),

        'stag_enrol_users'    => array(
                'classname'   => 'local_stag_course_external',
                'methodname'  => 'stag_enrol_users',
                'classpath'   => 'local/stag/externallib.php',
                'description' => 'Enrol user to course and adds STAG attribute',
                'type'        => 'write',
        ),
        'stag_get_grade'      => array(
                'classname'   => 'local_stag_course_external',
                'methodname'  => 'stag_get_grade',
                'classpath'   => 'local/stag/externallib.php',
                'description' => 'Return user\'s grade in course',
                'type'        => 'read',
        ),
        'stag_get_user_id'    => array(
                'classname'   => 'local_stag_course_external',
                'methodname'  => 'stag_get_user_id',
                'classpath'   => 'local/stag/externallib.php',
                'description' => 'Return identifier of the user',
                'type'        => 'read'
        ),
        'stag_unassign_role'   => array(
                'classname'   => 'local_stag_course_external',
                'methodname'  => 'stag_unassign_role',
                'classpath'   => 'local/stag/externallib.php',
                'description' => 'Unassign user/role from course',
                'type'        => 'write'
        ),
);
