<?php
/**
 * <p>Postupne otestuje vsechny nase sluzby.</p>
 * @author Pragodata {@link http://pragodata.cz}
 */
require_once('./ws_config.php');

/**
 * stavajici kategorie
 */
$functionname = 'core_course_get_categories';
$serverurl = $domainname . '/webservice/rest/server.php'. '?wstoken=' . $token . '&wsfunction='.$functionname;
$params = array();  //return all categories
// $params = array('criteria' => array(array('key' => 'id', 'value' => '2')), 'addsubcategories' => 0); //return one category
$resp_json = $curl->post($serverurl . $restformat, $params);
$exists_categories = json_decode($resp_json);
echo "\r\n".'-----------------'."\r\n";
echo "\r\n".'Exists categories'."\r\n";
echo "\r\n".'-----------------'."\r\n";
print_r($exists_categories);
echo "\r\n".'-----------------'."\r\n"."\r\n";

/**
 * pokud nase testovaci jeste neexistuje, pak ji vytvori
 */
$category_exists=false;
foreach($exists_categories as $category){
	if(\strpos($category->name, $category_name)===0){
		$category_exists=true;
		$pragodata_category=$category;
		break;
	}
}
if(!$category_exists){
	$functionname = 'core_course_create_categories';
	$serverurl = $domainname . '/webservice/rest/server.php'. '?wstoken=' . $token . '&wsfunction='.$functionname;
	$params=array();
	$params['categories'][0]['name']= $category_name;
	$resp_json = $curl->post($serverurl . $restformat, $params);
	$pragodata_category = json_decode($resp_json);
	echo "\r\n".'------------'."\r\n";
	echo "\r\n".'New category'."\r\n";
	echo "\r\n".'------------'."\r\n";
	print_r($pragodata_category);
	echo "\r\n".'------------'."\r\n"."\r\n";
}

/**
 * overi, zda jde kategorie editovat
 */
if(!empty($pragodata_category)){
	$category_name_arr=explode(' ', $pragodata_category->name);
	if(\count($category_name_arr)===2){
		$new_category_name=$category_name.' 002';
	}
	else{
		$old_int=(int)$category_name_arr[2];
		$new_category_name=$category_name.' '.\str_pad(++$old_int, 3, 0, \STR_PAD_LEFT);
	}
	$functionname = 'core_course_update_categories';
	$serverurl = $domainname . '/webservice/rest/server.php'. '?wstoken=' . $token . '&wsfunction='.$functionname;
	$params=array();
	$params['categories'][0]['id']=$pragodata_category->id;
	$params['categories'][0]['name']= $new_category_name;
	$resp_json = $curl->post($serverurl . $restformat, $params);
	$edited_category = json_decode($resp_json);
	echo "\r\n".'-----------------'."\r\n";
	echo "\r\n".'New category name'."\r\n";
	echo "\r\n".'-----------------'."\r\n";
	print_r($new_category_name);
	echo "\r\n".'-----------------'."\r\n"."\r\n";

	/**
	 * stavajici kurzy
	 */
	$function_name_get_courses = 'stag_get_courses';
	$serverurl = $domainname . '/webservice/rest/server.php'. '?wstoken=' . $token . '&wsfunction='.$function_name_get_courses;
	$params2 = array('options' => array());  //return tree courses
	$resp_json_get_courses = $curl->post($serverurl . $restformat, $params2);
	$all_courses = json_decode($resp_json_get_courses);

	echo "\r\n".'-----------'."\r\n";
	echo "\r\n".'All courses'."\r\n";
	echo "\r\n".'-----------'."\r\n";
	print_r($all_courses);
	echo "\r\n".'-----------'."\r\n"."\r\n";

	/**
	 * vytvoreni kurzu
	 */
	$pragodata_course_exists=false;
	foreach($all_courses as $course){
		if($course->name===$pragodata_course['name']){
			$pragodata_course_exists=true;
			$exists_course=$course;
		}
	}
	if(!$pragodata_course_exists){
		$functionname = 'stag_create_course';
		$serverurl = $domainname . '/webservice/rest/server.php'. '?wstoken=' . $token . '&wsfunction='.$functionname;
		$pragodata_course['categoryid']=$pragodata_category->id;
		$params=array();
		$params['course']=$pragodata_course;
		$resp_json = $curl->post($serverurl . $restformat, $params);
		$resp = json_decode($resp_json);
		echo "\r\n".'-----------------'."\r\n";
		echo "\r\n".'Created course id'."\r\n";
		echo "\r\n".'-----------------'."\r\n";
		print_r($resp);
		echo "\r\n".'-----------------'."\r\n"."\r\n";
	}

	/**
	 * zjisteni id uzivatele
	 */
	$functionname_get_user_id = 'stag_get_user_id';
	$serverurl = $domainname . '/webservice/rest/server.php'. '?wstoken=' . $token . '&wsfunction='.$functionname_get_user_id;
	$params_get_user_id = array('username' => $student_user['username']);
	$resp_json_get_user_id = $curl->post($serverurl . $restformat, $params_get_user_id);
	$student_user_id = json_decode($resp_json_get_user_id);
	echo "\r\n".'----------------'."\r\n";
	echo "\r\n".'Student user id'."\r\n";
	echo "\r\n".'----------------'."\r\n";
	print_r($student_user_id);
	echo "\r\n".'----------------'."\r\n"."\r\n";

	/**
	 * zjisteni celeho uzivatele
	 */
	if(!\is_object($student_user_id)){
		$functionname = 'core_user_get_users';
		$serverurl = $domainname . '/webservice/rest/server.php'. '?wstoken=' . $token . '&wsfunction='.$functionname;
		$params = array(
				'criteria'=>array(
						array('key'=>'id','value' => $student_user_id),
						)
				); //return one user
		$resp_json = $curl->post($serverurl . $restformat, $params);
		$resp = json_decode($resp_json);
		$student_user_object=(!empty($resp->users[0]) ? $resp->users[0] : $resp);
		echo "\r\n".'-------------------'."\r\n";
		echo "\r\n".'Student user object'."\r\n";
		echo "\r\n".'-------------------'."\r\n";
		print_r($student_user_object);
		echo "\r\n".'-------------------'."\r\n"."\r\n";
	}

	/**
	 * vytvoreni uzivatele
	 */
	if(empty($student_user_object)){
		$functionname = 'core_user_create_users';
		$serverurl = $domainname . '/webservice/rest/server.php'. '?wstoken=' . $token . '&wsfunction='.$functionname;
		$params=array();
		$params['users'][0]=$student_user;
		$resp_json = $curl->post($serverurl . $restformat, $params);
		$resp = json_decode($resp_json);
		echo "\r\n".'------------'."\r\n";
		echo "\r\n".'Created user'."\r\n";
		echo "\r\n".'------------'."\r\n";
		print_r($resp);
		echo "\r\n".'------------'."\r\n"."\r\n";
	}

	/**
	 * editace uzivatele
	 */
	if(!empty($student_user_object)){
		$functionname2 = 'core_user_update_users';
		$serverurl2 = $domainname . '/webservice/rest/server.php'. '?wstoken=' . $token . '&wsfunction='.$functionname2;
		$id_number=($student_user_object->idnumber ? ((int)$student_user_object->idnumber)+1 : 1);
		$params=array();
		$params['users'][0]=$student_user;
		$params['users'][0]['id']=$student_user_id;
		$params['users'][0]['idnumber']=$id_number;
		$resp_json2 = $curl->post($serverurl2 . $restformat, $params);
		$resp = json_decode($resp_json2);
		echo "\r\n".'--------------------'."\r\n";
		echo "\r\n".'Edited user idnumber'."\r\n";
		echo "\r\n".'--------------------'."\r\n";
		print_r($id_number);
		echo "\r\n".'--------------------'."\r\n"."\r\n";
	}

	/**
	 * zapise uzivatele do kurzu
	 */
	if(!empty($student_user_id) && !empty($exists_course)){
		$functionname2 = 'stag_enrol_users';
		$serverurl2 = $domainname . '/webservice/rest/server.php'. '?wstoken=' . $token . '&wsfunction='.$functionname2;
		$params = array('enrolment' => array('roleid' => $student_role_id, 'userid' => $student_user_id, 'courseid' => $exists_course->id));
		$resp_json2 = $curl->post($serverurl2 . $restformat, $params);
		$resp = json_decode($resp_json2);
		echo "\r\n".'----------'."\r\n";
		echo "\r\n".'Enrol user'."\r\n";
		echo "\r\n".'----------'."\r\n";
		print_r($resp);
		echo "\r\n".'----------'."\r\n"."\r\n";
	}

	/**
	 * ziska studijni vysledky
	 */
	if(!empty($student_user_id) && !empty($exists_course)){
		$functionname = 'stag_get_grade';
		$serverurl = $domainname . '/webservice/rest/server.php'. '?wstoken=' . $token . '&wsfunction='.$functionname;
		$params = array('grade_of' => array('username' => $student_user['username'], 'course_id' => $exists_course->id)); //return one category
		$resp_json = $curl->post($serverurl . $restformat, $params);
		$resp = json_decode($resp_json);
		echo "\r\n".'---------'."\r\n";
		echo "\r\n".'Get grade'."\r\n";
		echo "\r\n".'---------'."\r\n";
		print_r($resp);
		echo "\r\n".'---------'."\r\n"."\r\n";
	}
}
